package edu.iastate.ece.afibdet;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

public class Main extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        switch (item.getItemId()){
            case R.id.menu_setup_monitor_connection:
                setupMonitorConnection(item.getActionView());
                return true;
            case R.id.menu_view_heart_rate:
                viewHeartRate(item.getActionView());
                return true;
            case R.id.menu_info:
                viewInfo(item.getActionView());
                return true;
            default:
                break;
        }

        return super.onOptionsItemSelected(item);
    }

    public void setupMonitorConnection(View view){
        Intent intent = new Intent(this, SetupMonitor.class);
        startActivity(intent);
    }

    public void viewHeartRate(View view){
        Intent intent = new Intent(this,HeartRate.class);
        //TODO possibly check if connection manager is associated
        startActivity(intent);
    }

    public void viewInfo(View view){
        AlertDialog.Builder dialog = new AlertDialog.Builder(this);
        dialog.setMessage(R.string.legal_info);
        dialog.setPositiveButton(" OK ", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int id) {
                dialog.dismiss();

            }
        });
        dialog.show();

    }
}
