package edu.iastate.ece.afibdet;

import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import com.github.mikephil.charting.data.Entry;

import java.util.Date;
import java.util.List;

/**
 * Created by seth on 4/15/2016.
 */
public class NewDataBroadcastReciever extends BroadcastReceiver {

    private Cursor getUnobserved(Context context){
        String[] proj = {HeartRateDatabaseProvider.TIME,HeartRateDatabaseProvider.VALUE,HeartRateDatabaseProvider.DETECTED};
        String query = "NOT " + HeartRateDatabaseProvider.OBSERVED + "!=?";
        String[] queryArgs = {"0"};
        String ordering = HeartRateDatabaseProvider.TIME + " ASC";

        return context.getContentResolver().query(HeartRateDatabaseProvider.CONTENT_URI,proj,query,queryArgs,ordering);
    }



    public void setObserved(long start, long end, Context context){
        ContentValues contentValues = new ContentValues();
        contentValues.put(HeartRateDatabaseProvider.OBSERVED,1);
        String where = HeartRateDatabaseProvider.TIME + ">=? AND " + HeartRateDatabaseProvider.TIME + "<=?";
        String[] args = {
                Long.toString(start),
                Long.toString(end)
        };
        context.getContentResolver().update(HeartRateDatabaseProvider.CONTENT_URI, contentValues, where, args);
    }

    @Override
    public void onReceive(Context context, Intent intent) {
        long lastTime=0,firstTime=0;
        Cursor cur = getUnobserved(context);
        if(cur.moveToFirst()){
            firstTime = cur.getInt(cur.getColumnIndex(HeartRateDatabaseProvider.TIME));
        }
        while(!cur.isAfterLast()){
            lastTime = cur.getInt(cur.getColumnIndex(HeartRateDatabaseProvider.TIME));
            cur.moveToNext();
        }
        cur.close();
        int n=0;
        Log.i("newData","times: " + firstTime + " / " + lastTime);

        if(firstTime != lastTime){
            setObserved(firstTime,lastTime,context);
        }

        Intent observedData = new Intent("edu.iastate.ece.afibdet.NEW_OBSERVED");
        observedData.putExtra("start",firstTime);
        observedData.putExtra("end", lastTime);
        context.sendBroadcast(observedData);
    }
}
